/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package demo.netbeans.testnbclientimpl;

import demo.netbeans.testejb.GreeterFacadeRemote;
import java.util.Date;
import java.util.Properties;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.naming.Context;
import javax.naming.InitialContext;

/**
 *
 * @author ojantz
 */
public abstract class EJBTester {
    
     
    
     public static void run(String... args) {

        Logger logger = Logger.getLogger(EJBTester.class.getName());

        String host = args[0];
        String port = args[1];

        Integer sleepingSecs = Integer.valueOf(args[2]);

        Properties properties = buildProperties(host, port);

  //      while (true) {
            //Context ctx = null;
            try {

//                Callable<String> task = new Callable<String>() {
//
//                    @Override
//                    public String call() throws Exception {


                logger.log(Level.INFO, "Trying to get initial context with props: " + properties.toString());
                Context ctx = new InitialContext(properties);
                logger.log(Level.INFO, "Got initial context.");
                String facadeName = GreeterFacadeRemote.class.getCanonicalName();
                logger.log(Level.INFO, "Trying to lookup remote facade: " + facadeName);
                //GreeterFacadeRemote facade = (GreeterFacadeRemote) ctx.lookup(facadeName);

                GreeterFacadeRemote facade = null;
                facade = (GreeterFacadeRemote) ctx.lookup(facadeName);


                if (facade == null) {
                    System.exit(1);
                }

                logger.log(Level.INFO, "Got facade instance: " + facade);
                logger.log(Level.INFO, "Calling method sayHelloTo(Client)");
                String result = facade.sayHelloTo("Client");
                System.out.println((new Date()) + ": " + result);
                logger.log(Level.INFO, "Called successfully.");

//                        return result;
//                    }
//                };
//
//                ExecutorService executor = Executors.newSingleThreadExecutor();
//                String result = executor.submit(task).get(20, TimeUnit.SECONDS);
//                executor.shutdown();



            } catch (Throwable ex) {

                boolean isTimeout = true;
//                Throwable inner = ex;
//                while(inner.getCause() != null) {
//                    inner = inner.getCause();
//                    if(inner instanceof org.omg.CORBA.COMM_FAILURE && inner.getMessage().toLowerCase().contains("waiting for response")) {
//                        isTimeout = true;
//                    }
//                }

                logger.log(Level.SEVERE, ex.getMessage(), ex);
                ex.printStackTrace();

                if (isTimeout) {
                    logger.log(Level.INFO, "Resuming after exception.");
           //         continue;
                } else {
             //       break;
                }

            } finally {
                Runtime.getRuntime().gc();
            }
       //     sleep(sleepingSecs);
         //   sleepingSecs = sleepingSecs + 15;
     //   }
    }

    private static Properties buildProperties(String host, String port) {
        Properties properties = new Properties();

        properties.setProperty("org.omg.CORBA.ORBInitialHost", host);
        properties.setProperty("org.omg.CORBA.ORBInitialPort", port);
        properties.setProperty("java.naming.factory.state", "com.sun.corba.ee.impl.presentation.rmi.JNDIStateFactoryImpl");
        properties.put("java.naming.factory.initial", "com.sun.enterprise.naming.SerialInitContextFactory");


        return properties;
    }

    private static void sleep(int sec) {
        Logger.getLogger(EJBTester.class.getName()).log(Level.INFO, "Waiting for " + sec + " seconds.");
        int i = 0;
        while (i < sec) {
            try {
                Thread.sleep(1000);
                System.out.print(".");
            } catch (InterruptedException ex) {
                Logger.getLogger(EJBTester.class.getName()).log(Level.SEVERE, null, ex);
            }
            i++;
        }
    }
    
}
